/*
 * Chords.java 0.1.0.3 5th November 2004
 *
 * Copyright (C) 2004 David Turner
 *
 * <This Java Class is part of the jMusic API version 1.4, December 2003.>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jm.constants;

public interface Chords {

    /** chord interval patterns */
	public final static int[] MAJOR = { 4, 7 };
	public final static int[] MINOR = { 3, 7 };
	public final static int[] AUGMENTED = { 4, 8 };
	public final static int[] DIMINISHED = { 3, 6 };
	public final static int[] SUSPENDED_FOURTH = { 5, 7 };
	public final static int[] FLATTED_FIFTH = { 4, 6 };
	public final static int[] SIXTH = { 4, 7, 9 };
	public final static int[] MINOR_SIXTH = { 3, 7, 9 };
	public final static int[] SEVENTH = { 4, 7, 10 };
	public final static int[] MINOR_SEVENTH = { 3, 7, 10 };
	public final static int[] MAJOR_SEVENTH = { 4, 7, 11 };
	public final static int[] SEVENTH_SHARP_FIFTH = { 4, 8, 10 };
	public final static int[] DIMINISHED_SEVENTH = { 4, 6, 9 };
	public final static int[] SEVENTH_FLAT_FIFTH = { 4, 6, 10 };
	public final static int[] MINOR_SEVENTH_FLAT_FIFTH = { 3, 6, 10 };
	public final static int[] SIXTH_ADDED_NINTH = { 4, 7, 9, 14 };
	public final static int[] SEVENTH_SHARP_NINTH = { 4, 7, 10, 15 };
	public final static int[] SEVENTH_FLAT_NINTH = { 4, 7, 10, 13 };
	public final static int[] NINTH = { 4, 7, 10, 14 };
	public final static int[] MINOR_NINTH = { 3, 7, 10, 14 };
	public final static int[] ELEVENTH = { 7, 10, 14, 17 };
	public final static int[] MINOR_ELEVENTH = { 3, 7, 10, 14, 17 };
	public final static int[] THIRTEENTH = { 4, 7, 10, 14, 21 };	
}
