/*

<This Java Class is part of the jMusic API version 1.5, March 2004.>

Copyright (C) 2000 Andrew Sorensen & Andrew Brown

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or any
later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

package jm.constants;

/** An interface storing rhythm value constants.
  * 
  * @see jm.music.data.Note
  * @author Andrew Sorensen, Andrew Brown, Andrew Troedson, Adam Kirby
  */
public interface Durations {
    
	public static final double 
		SB = 4.0, SEMIBREVE = 4.0, WHOLE_NOTE = 4.0, WN = 4.0, 
		MD = 3.0, DM = 3.0, DOTTED_MINIM = 3.0, DOTTED_HALF_NOTE = 3.0,
                                DHN = 3.0,
		MDD = 3.5, DDM = 3.5, DOUBLE_DOTTED_MINIM = 3.5, 
                                DOUBLE_DOTTED_HALF_NOTE = 3.5, DDHN = 3.5,
		M = 2.0, MINIM = 2.0, HALF_NOTE = 2.0, HN = 2.0,
		MT = 4.0/3.0, MINIM_TRIPLET = 4.0/3.0, 
                                HALF_NOTE_TRIPLET = 4.0/3.0, HNT = 4.0/3.0,
		C = 1.0, CROTCHET = 1.0, QUARTER_NOTE = 1.0, QN = 1.0,
		CT = 2.0/3.0, CROTCHET_TRIPLET = 2.0/3.0, 
                                QUARTER_NOTE_TRIPLET = 2.0/3.0, QNT = 2.0/3.0,
		CD = 1.5, DC = 1.5, DOTTED_CROTCHET = 1.5,  
                                DOTTED_QUARTER_NOTE = 1.5, DQN = 1.5,
		CDD = 1.75, DDC = 1.75, DOUBLE_DOTTED_CROTCHET = 1.75,  
                                DOUBLE_DOTTED_QUARTER_NOTE = 1.75, DDQN = 1.75,
		Q = 0.5, QUAVER = 0.5, EIGHTH_NOTE = 0.5, EN = 0.5,
		QD = 0.75, DQ = 0.75, DOTTED_QUAVER = 0.75, 
                                DOTTED_EIGHTH_NOTE = 0.75, DEN = 0.75,
		QT = 1.0/3.0, QUAVER_TRIPLET = 1.0/3.0, 
                                EIGHTH_NOTE_TRIPLET = 1.0/3.0, ENT = 1.0/3.0,
                DDQ = 0.875, QDD = 0.875, DOUBLE_DOTTED_QUAVER = 0.875, 
                                DOUBLE_DOTTED_EIGHTH_NOTE = 0.875, DDEN = 0.875,
		SQ = 0.25, SEMI_QUAVER = 0.25, SIXTEENTH_NOTE = 0.25, SN = 0.25,
		SQD = 0.375, DOTTED_SEMI_QUAVER = 0.375, 
                                DOTTED_SIXTEENTH_NOTE = 0.375, DSN = 0.375,
		SQT = 1.0/6.0, SEMI_QUAVER_TRIPLET = 1.0/6.0, 
                                SIXTEENTH_NOTE_TRIPLET = 1.0/6.0, SNT = 1.0/6.0,
		DSQ = 0.125, DEMI_SEMI_QUAVER = 0.125, 
                                THIRTYSECOND_NOTE = 0.125, TN = 0.125,
                                TSN = 0.125,
		DSQT = 1.0/12.0, DEMI_SEMI_QUAVER_TRIPLET = 1.0/12.0, 
                                THIRTYSECOND_NOTE_TRIPLET = 1.0/12.0, 
                                TNT = 1.0/12.0, TSNT = 1.0/12.0;

}