/*

<This Java Class is part of the jMusic API version 1.5, March 2004.>

Copyright (C) 2000-2003 Andrew Sorensen & Andrew Brown

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or any
later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

package jm.constants;

/** An interface storing scale constants.
  * 
  * @see jm.music.data.Note
  * @author Andrew Sorensen, Andrew Brown, Andrew Troedson, Adam Kirby
  */
public interface Scales {

        public static final int[] 
                CHROMATIC_SCALE = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11},
                MAJOR_SCALE = {0, 2, 4, 5, 7, 9, 11},
                MINOR_SCALE = {0, 2, 3, 5, 7, 8, 10},
                HARMONIC_MINOR_SCALE = {0, 2, 3, 5, 7, 8, 11},
                MELODIC_MINOR_SCALE = {0, 2, 3, 5, 7, 8, 9, 10, 11}, // mix of ascend and descend
                NATURAL_MINOR_SCALE = {0, 2, 3, 5, 7, 8, 10},
                DIATONIC_MINOR_SCALE = {0, 2, 3, 5, 7, 8, 10},
                AEOLIAN_SCALE = {0, 2, 3, 5, 7, 8, 10},
                DORIAN_SCALE = {0, 2, 3, 5, 7, 9, 10},	
                LYDIAN_SCALE = {0, 2, 4, 6, 7, 9, 11},
                MIXOLYDIAN_SCALE = {0, 2, 4, 5, 7, 9, 10},
                PENTATONIC_SCALE = {0, 2, 4, 7, 9},
                BLUES_SCALE = {0, 2, 3, 4, 5, 7, 9, 10, 11},
                TURKISH_SCALE = {0, 1, 3, 5, 7, 10, 11},
                INDIAN_SCALE = {0, 1, 1, 4, 5, 8, 10};
       
}