/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package database;

import data.IMotif;
import data.INote;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author smuRf
 */
public class DatabaseInterface {
    private Database database;
    
    public DatabaseInterface(String user, String pass, String url)
    {
        database = new Database(user, pass, url);
    }
    
    public boolean isDatabaseConnectionUp()
    {
        return database.isConnectionUp();
    }
    
    private boolean exists(IMotif motif)
    {
        ArrayList<Integer> motifIds = new ArrayList();
        ArrayList<INote> iNotes = new ArrayList();
        ResultSet rs = database.select("SELECT id FROM PBMC.motif");
        try {
            while(rs.next())
            {
                motifIds.add(rs.getInt("id"));
            }
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        boolean ret = false;
        if(!motifIds.isEmpty())
        {
            for(int id:motifIds)
            {
                iNotes.clear();
                rs = database.select("SELECT * FROM PBMC.note WHERE motif_id="+id+" ORDER BY id");
                try {
                    while(rs.next())
                    {
                        iNotes.add(new INote(rs.getString("note"), rs.getDouble("duration"), rs.getInt("real_duration"), rs.getInt("pitch"), rs.getDouble("rhythm_value"), rs.getInt("dynamic")));
                    }
                    
                    if(!iNotes.isEmpty())
                    {
                        if(motif.equals(iNotes))
                        {
                            ret = true;
                            break;
                        }
                    }
                } catch (SQLException ex) {
                    Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
        return ret;
    }

    public void closeConnection() 
    {
        database.closeConnection();
        System.err.println("disconnected from database");
    }
    
    public HashMap<String, Integer> getCategories(String username)
    {
        ResultSet rs = database.select("SELECT id FROM PBMC.user WHERE name='" + username + "'");
        HashMap<String, Integer> categories = new HashMap();
        
        try {
            if(!username.isEmpty())
            {
                rs.first();
                int userId = rs.getInt("id");
                rs = database.select("SELECT * FROM PBMC.category WHERE user_id='" + userId + "'");
            }
            else
                rs = database.select("SELECT * FROM PBMC.category");
        
            while(rs.next())
                categories.put(rs.getString("category_name"), rs.getInt("id"));
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return categories;
    }
    
    public int getCategoryIdForName(String name)
    {
        int id = -1;
        try {
            ResultSet rs = database.select("SELECT id FROM PBMC.category WHERE category_name='"+name+"'");
            if(rs.next())
                id = rs.getInt("id");
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return id;
    }
    
    public String getCreatorOfCategory(int categoryId)
    {
        String username = "";
        ResultSet rs = database.select("SELECT user_id FROM PBMC.category WHERE id='"+categoryId+"'");
        try {
            while(rs.next())
            {
                int userId = rs.getInt("user_id");
                rs = database.select("SELECT name FROM PBMC.user WHERE id='"+userId+"'");
                rs.first();
                username = rs.getString("name");
                break;
            }
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return username;
    }
    
    public String getCreatorOfMotif(int motifId)
    {
        String username = "";
        ResultSet rs = database.select("SELECT user_id FROM PBMC.motif WHERE id='"+motifId+"'");
        try {
            while(rs.next())
            {
                int userId = rs.getInt("user_id");
                rs = database.select("SELECT name FROM PBMC.user WHERE id='"+userId+"'");
                rs.first();
                username = rs.getString("name");
                break;
            }
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return username;
    }
    
    public ArrayList<Integer> getMotifsIdsOfCategoryId(int categoryId)
    {
        ArrayList<Integer> ids = new ArrayList();
        
        try {
            ResultSet rs;
            
            rs = database.select("SELECT id FROM PBMC.motif WHERE category_id='"+categoryId+"'");
            
            while(rs.next())
            {
                ids.add(rs.getInt("id"));
            }
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return ids;
    }
    
    public int getIdForUsername(String name)
    {
        ResultSet rs = database.select("SELECT id FROM PBMC.user WHERE name='"+name+"'");
        try {
            while(rs.next())
                return rs.getInt("id");
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return -1;
    }
    
    public ArrayList<Integer> getMotifsIds(String username)
    {
        ArrayList<Integer> ids = new ArrayList();
        
        try {
            ResultSet rs;
            
            if(username==null)
                rs = database.select("SELECT id FROM PBMC.motif");
            else
            {
                rs = database.select("SELECT id FROM PBMC.motif WHERE user_id='"+getIdForUsername(username)+"'");
            }
            
            while(rs.next())
            {
                ids.add(rs.getInt("id"));
            }
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return ids;
    }
    
    public void setNewPassword(String username, String password)
    {
        try {
            ResultSet rs = database.select("SELECT id from PBMC.user WHERE name='"+username+"'");
            int id=-1;
            
            while(rs.next())
                id = rs.getInt("id");
            
            database.update("UPDATE PBMC.user SET password=MD5('"+password+"') WHERE id="+id);
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    public boolean login(String user, String pass)
    {
        ResultSet rs = database.select("SELECT * FROM PBMC.user WHERE name='"+user+"' AND password=MD5('"+pass+"')");
        try {
            while(rs.next())
            {
                return true;
            }
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        return false;
    }
    
    public boolean login(String user, byte[] pass)
    {
        ResultSet rs = database.select("SELECT password FROM PBMC.user WHERE name='"+user+"'");
        try {
            while(rs.next())
            {
                byte[] array = rs.getBytes("password");
                boolean ret = true;
                for(int i = 0; i < array.length; i++)
                {
                    if(array[i] != pass[i])
                    {
                        ret = false;
                        break;
                    }
                }
                return ret;
            }
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        return false;
    }
    
    public String getMotifName(int id)
    {
        String name = "";
        
        try {
            ResultSet rs = database.select("SELECT name FROM PBMC.motif WHERE id="+id);
            
            while(rs.next())
            {
                name = rs.getString("name");
            }
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        return name;
    }
    
    public double getMotifTempo(int id)
    {
        double tempo = -1;
        
        try {
            ResultSet rs = database.select("SELECT tempo FROM PBMC.motif WHERE id="+id);
            
            while(rs.next())
            {
                tempo = rs.getDouble("tempo");
            }
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        return tempo;
    }
    
    public int getMotifPPQN(int id)
    {
        int ppqn = -1;
        
        try {
            ResultSet rs = database.select("SELECT ppqn FROM PBMC.motif WHERE id="+id);
            
            while(rs.next())
            {
                ppqn = rs.getInt("ppqn");
            }
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        return ppqn;
    }
    
    public int getMotifDefaultInstrument(int id)
    {
        int instrument = -1;
        
        try {
            ResultSet rs = database.select("SELECT default_instrument FROM PBMC.motif WHERE id="+id);
            
            while(rs.next())
            {
                instrument = rs.getInt("default_instrument");
            }
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        return instrument;
    }
    
    public ArrayList<INote> getMotifDetails(int id)
    {
        ArrayList<INote> notes = new ArrayList();
        
        try {
            ResultSet rs = database.select("SELECT * FROM PBMC.note WHERE motif_id="+id+" ORDER BY id");
                    
            while(rs.next())
            {
                int dynamic = rs.getInt("dynamic");
                double rhythmValue = rs.getDouble("rhythm_value");
                double duration = rs.getDouble("duration");
                double realDuration = rs.getDouble("real_duration");
                int pitch = rs.getInt("pitch");
                String note = rs.getString("note");

                INote iNote;
                if(pitch == Integer.MIN_VALUE) // REST
                    iNote = new INote("REST", duration, realDuration, rhythmValue, dynamic);
                else
                    iNote = new INote(note, (pitch/12)-1, duration, realDuration, pitch, rhythmValue, dynamic);

                notes.add(iNote);
            }
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return notes;
    }
    
    public int insertCategory(String name, String username)
    {
        try {
            ResultSet rs = database.select("SELECT category_name FROM PBMC.category WHERE category_name='"+name+"'");
            int id;
            if(!rs.next())
            {
                rs = database.select("SELECT id FROM PBMC.user WHERE name='"+username+"'");
                rs.first();
                int userId = rs.getInt("id");
                id = database.insert("INSERT INTO PBMC.category(user_id,category_name) VALUES("+userId+",'"+name+"')");
            }
            else
                id = -1;
            return id;
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
        return -1;
    }
    
    public void insertMotif(IMotif motif, String username, int categoryId)
    {
        try {
            if(!exists(motif))
            {
                ResultSet rs = database.select("SELECT id FROM PBMC.user WHERE name='"+username+"'");
                int userId = -1;
                while(rs.next())
                    userId = rs.getInt("id");

                int id = database.insert("INSERT INTO PBMC.motif(user_id,category_id,name,tempo,default_instrument,ppqn) VALUES("+userId+","+categoryId+",'"+motif.getName()+"',"+motif.getTempo()+","+motif.getDefaultInstrument()+","+motif.getIScore().getPPQN()+")");

                for(INote iNote:motif.getNotes())
                {
                    database.insert("INSERT INTO PBMC.note(motif_id,note,pitch,dynamic,rhythm_value,duration,real_duration) VALUES("+id+",'"+iNote.getINote()+"',"+iNote.getPitch()+","+iNote.getDynamic()+","+iNote.getRhythmValue()+","+iNote.getDuration()+","+iNote.getRealDuration()+")");
                }
                System.err.println("motif added to database");
            }
            else
            {
                System.err.println("motif already exists in database");
            }
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseInterface.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
