/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import data.INote;
import data.IPart;
import data.IPhrase;
import data.IScore;
import database.DatabaseInterface;
import java.awt.Rectangle;
import java.awt.event.ItemEvent;
import java.util.ArrayList;
import java.util.HashMap;
import javax.swing.JCheckBox;
import javax.swing.table.DefaultTableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;
import midi.MIDIPlayer;

/**
 *
 * @author smuRf
 */
public class MotifDatabaseDialog extends javax.swing.JDialog implements CheckChangeListener{
    private DatabaseInterface databaseInterface;
    private ArrayList<INote> notes = null;
    private int selectedId = -1;
    private MainGui parent;
    private HashMap<Integer, Boolean> selectedMotifs = new HashMap();
    private CheckTreeManager checkTreeManager;
    
    /**
     * Creates new form MotifDetectionDialog
     */
    public MotifDatabaseDialog(java.awt.Frame parent, boolean modal, HashMap composeMotifs) {
        super(parent, modal);
        initComponents();
        
        this.parent = (MainGui)parent;
        
        checkTreeManager = new CheckTreeManager(jtMotifs, this); 

        selectedMotifs = composeMotifs==null?new HashMap():composeMotifs;
        
        Rectangle parentBounds = this.parent.getBounds();
        this.setBounds((int)(parentBounds.getWidth()/2-getBounds().getWidth()/2) + (int)parentBounds.getX(), 
                       (int)(parentBounds.getHeight()/2-getBounds().getHeight()/2) + (int)parentBounds.getY(), 
                       (int)getBounds().getWidth(), (int)getBounds().getHeight());
        
        databaseInterface = new DatabaseInterface(MainGui.DB_USER, MainGui.DB_PASSWORD, MainGui.DB_URL);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        toolbar = new javax.swing.JToolBar();
        btnPlay = new javax.swing.JButton();
        btnStop = new javax.swing.JButton();
        pnltoolbar = new javax.swing.JPanel();
        lblFilter = new javax.swing.JLabel();
        cbFilter = new javax.swing.JComboBox();
        splitPane = new javax.swing.JSplitPane();
        pMotifs = new javax.swing.JPanel();
        spMotifs = new javax.swing.JScrollPane();
        jtMotifs = new javax.swing.JTree();
        pMotifData = new javax.swing.JPanel();
        spMotifData = new javax.swing.JScrollPane();
        taMotifData = new javax.swing.JTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Motif database");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
            public void windowActivated(java.awt.event.WindowEvent evt) {
                formWindowActivated(evt);
            }
        });

        toolbar.setRollover(true);

        btnPlay.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/play.png"))); // NOI18N
        btnPlay.setToolTipText("Play");
        btnPlay.setFocusable(false);
        btnPlay.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnPlay.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnPlay.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnPlayActionPerformed(evt);
            }
        });
        toolbar.add(btnPlay);

        btnStop.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/stop.png"))); // NOI18N
        btnStop.setToolTipText("Stop");
        btnStop.setFocusable(false);
        btnStop.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnStop.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnStop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnStopActionPerformed(evt);
            }
        });
        toolbar.add(btnStop);

        pnltoolbar.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 5, 0));

        lblFilter.setText("filter: ");
        pnltoolbar.add(lblFilter);

        cbFilter.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "mine", "all" }));
        cbFilter.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                cbFilterItemStateChanged(evt);
            }
        });
        pnltoolbar.add(cbFilter);

        toolbar.add(pnltoolbar);

        getContentPane().add(toolbar, java.awt.BorderLayout.PAGE_START);

        splitPane.setDividerSize(2);

        pMotifs.setLayout(new java.awt.BorderLayout());

        spMotifs.setPreferredSize(new java.awt.Dimension(200, 322));

        javax.swing.tree.DefaultMutableTreeNode treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("motifs");
        jtMotifs.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        jtMotifs.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jtMotifsValueChanged(evt);
            }
        });
        spMotifs.setViewportView(jtMotifs);

        pMotifs.add(spMotifs, java.awt.BorderLayout.CENTER);

        splitPane.setLeftComponent(pMotifs);

        pMotifData.setLayout(new java.awt.BorderLayout());

        taMotifData.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "note", "pitch", "rhythm value"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Integer.class, java.lang.Double.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        taMotifData.getTableHeader().setReorderingAllowed(false);
        spMotifData.setViewportView(taMotifData);

        pMotifData.add(spMotifData, java.awt.BorderLayout.CENTER);

        splitPane.setRightComponent(pMotifData);

        getContentPane().add(splitPane, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    public void checkStateChanged(JCheckBox editor, int state)
    {
        if(state == ItemEvent.SELECTED)
            selectedMotifs.put(Integer.parseInt(editor.getText()), true);
        else
            selectedMotifs.put(Integer.parseInt(editor.getText()), false);
    }
    
    private void fillTableWithMotifs(String username)
    {
        DefaultMutableTreeNode root = (DefaultMutableTreeNode)jtMotifs.getModel().getRoot();
        root.removeAllChildren();
        jtMotifs.updateUI();
        
        HashMap<String, Integer> categories = databaseInterface.getCategories(username);
        ArrayList<TreePath> treePaths = new ArrayList();
        
        for(String name:categories.keySet())
        {
            String categoryUsername = databaseInterface.getCreatorOfCategory(categories.get(name));
            DefaultMutableTreeNode categoryNode = new DefaultMutableTreeNode(name + " [" + categoryUsername + "]");
            root.add(categoryNode);
            
            TreePath parentTreePath = new TreePath(root);
            parentTreePath = parentTreePath.pathByAddingChild(categoryNode);
            
            ArrayList<Integer> motifIds = databaseInterface.getMotifsIdsOfCategoryId(categories.get(name));
            
            for(int id:motifIds)
            {
                String motifUsername = databaseInterface.getCreatorOfMotif(id);
                DefaultMutableTreeNode motifNode = new DefaultMutableTreeNode(id + " [" + motifUsername + "]");
                categoryNode.add(motifNode);
                
                if(selectedMotifs.containsKey(id))
                {
                    TreePath childTreePath = parentTreePath.pathByAddingChild(motifNode);
                    treePaths.add(childTreePath);
                }
            }
        }

        TreePath[] treePathArray = new TreePath[treePaths.size()];
        for(int i = 0; i < treePaths.size(); i++)
                treePathArray[i] = treePaths.get(i);
        
        checkTreeManager.getSelectionModel().setSelectionPaths(treePathArray);
        jtMotifs.updateUI();
    }
    
    private void btnPlayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnPlayActionPerformed
        MIDIPlayer.play(buildUpIScoreFromDatabase(selectedId));
    }//GEN-LAST:event_btnPlayActionPerformed

    private void btnStopActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnStopActionPerformed
        MIDIPlayer.stop();
    }//GEN-LAST:event_btnStopActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        databaseInterface.closeConnection();
        parent.setComposeMotifs(selectedMotifs);
    }//GEN-LAST:event_formWindowClosing

    private void cbFilterItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_cbFilterItemStateChanged
        String filter = (String)evt.getItem();
        
        if(filter.equals("mine"))
            fillTableWithMotifs(parent.getLoggedInUsername());
        else
            fillTableWithMotifs("");
    }//GEN-LAST:event_cbFilterItemStateChanged

    private void jtMotifsValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jtMotifsValueChanged
        DefaultMutableTreeNode node = (DefaultMutableTreeNode) evt.getPath().getLastPathComponent();
        DefaultTableModel tableModel = (DefaultTableModel) taMotifData.getModel();
        int rowCount = tableModel.getRowCount();
        for(int i = 0; i < rowCount; i++)
            tableModel.removeRow(0);
        
        try
        {
            selectedId = Integer.parseInt(((String)node.getUserObject()).split(" ")[0]);
            notes = databaseInterface.getMotifDetails(selectedId);
            for(INote note:notes)
            {
                tableModel.insertRow(tableModel.getRowCount(), new Object[]{note.getName(), note.getPitch(), note.getRhythmValue()});
            }
        } catch(NumberFormatException ex)
        {

        }
    }//GEN-LAST:event_jtMotifsValueChanged

    private void formWindowActivated(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowActivated
        fillTableWithMotifs(this.parent.getLoggedInUsername());
    }//GEN-LAST:event_formWindowActivated

    private IScore buildUpIScoreFromDatabase(int id)
    {
        IScore iScore = new IScore("", databaseInterface.getMotifTempo(id));
        iScore.setPPQN(databaseInterface.getMotifPPQN(id));
        IPart iPart = new IPart("", databaseInterface.getMotifDefaultInstrument(id), 0);
        IPhrase iPhrase = new IPhrase("", 0);
        
        for(INote note:notes)
            iPhrase.addINote(note);
        
        iScore.addIPart(iPart);
        iPart.addIPhrase(iPhrase);
        
        return iScore;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /*
         * Set the Nimbus look and feel
         */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
         * If Nimbus (introduced in Java SE 6) is not available, stay with the
         * default look and feel. For details see
         * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MotifDatabaseDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MotifDatabaseDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MotifDatabaseDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MotifDatabaseDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /*
         * Create and display the dialog
         */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                MotifDatabaseDialog dialog = new MotifDatabaseDialog(new javax.swing.JFrame(), true, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnPlay;
    private javax.swing.JButton btnStop;
    private javax.swing.JComboBox cbFilter;
    private javax.swing.JTree jtMotifs;
    private javax.swing.JLabel lblFilter;
    private javax.swing.JPanel pMotifData;
    private javax.swing.JPanel pMotifs;
    private javax.swing.JPanel pnltoolbar;
    private javax.swing.JScrollPane spMotifData;
    private javax.swing.JScrollPane spMotifs;
    private javax.swing.JSplitPane splitPane;
    private javax.swing.JTable taMotifData;
    private javax.swing.JToolBar toolbar;
    // End of variables declaration//GEN-END:variables

    @Override
    public void checkChanged(ArrayList<TreePath> paths) {
        selectedMotifs.clear();
        for(TreePath path:paths)
        {
            if(path.getParentPath() != null && path.getParentPath().getParentPath() != null)
            {
                DefaultMutableTreeNode node = (DefaultMutableTreeNode)path.getLastPathComponent();
                int id = Integer.parseInt(((String)node.getUserObject()).split(" ")[0]);
                selectedMotifs.put(id, true);
            }
        }
    }
}
